package test.rewolucja.resources.manager.implementation;

import java.util.ArrayList;
import java.util.List;
import java.util.Properties;

import test.rewolucja.resources.ResourceType;
import test.rewolucja.resources.exception.ResourceException;
import test.rewolucja.resources.logical.base.LogicalResource;

import test.rewolucja.resources.physical.base.ComputingResource;
import test.rewolucja.resources.physical.implementation.Processor;
import test.rewolucja.resources.physical.implementation.ComputingNode;

public class ClusterResourceManager extends ResourceManager{

	public ClusterResourceManager(List<ComputingResource> resources, List<LogicalResource> logicalLayers) {
		super(resources, logicalLayers);
		// TODO Auto-generated constructor stub
	}

	@SuppressWarnings("unchecked")
	public List<ComputingNode> getComputingNodes(){
		try {
			return (List<ComputingNode>) getResourcesOfType(ResourceType.COMPUTING_NODE);
		} catch (ResourceException e) {
			return new ArrayList<ComputingNode>();
		}
	}
	
	@SuppressWarnings("unchecked")
	public List<Processor> getProcessors(){
		try {
			return (List<Processor>) getResourcesOfType(ResourceType.CPU);
		} catch (Exception e) {
			return new ArrayList<Processor>();
		}
	}

	@SuppressWarnings("unchecked")
	public List<ComputingNode> getComputingNodes(Properties properties){
		properties.setProperty("type", ResourceType.COMPUTING_NODE.toString());
		return (List<ComputingNode>) filterResources(properties);

	}

}
